hlib = ../HTKLib
CC = gcc 
CFLAGS = -I/usr/include -I$(hlib) -ansi

HCode:  $(hlib)/HTKLib.a HCode.o
	$(CC) HCode.o  $(hlib)/HTKLib.a  -lm
	mv a.out $(HOME)/bin/HCode

HList:  $(hlib)/HTKLib.a HList.o
	$(CC) HList.o $(hlib)/HTKLib.a -lm
	mv a.out $(HOME)/bin/HList

HInit:  $(hlib)/HTKLib.a HInit.o HKMeans.o
	$(CC) HInit.o HKMeans.o $(hlib)/HTKLib.a -lm
	mv a.out $(HOME)/bin/HInit

HRest:  $(hlib)/HTKLib.a HRest.o
	$(CC) HRest.o  $(hlib)/HTKLib.a -lm
	mv a.out $(HOME)/bin/HRest

HERest:  $(hlib)/HTKLib.a HERest.o
	$(CC) HERest.o  $(hlib)/HTKLib.a -lm
	mv a.out $(HOME)/bin/HERest

HVite:  $(hlib)/HTKLib.a HVite.o
	$(CC) HVite.o  $(hlib)/HTKLib.a -lm
	mv a.out $(HOME)/bin/HVite

HMixUp:  $(hlib)/HTKLib.a HMixUp.o
	$(CC) HMixUp.o $(hlib)/HTKLib.a -lm
	mv a.out $(HOME)/bin/HMixUp
		
HResults:  $(hlib)/HTKLib.a HResults.o
	$(CC) HResults.o $(hlib)/HTKLib.a -lm
	mv a.out $(HOME)/bin/HResults
		
HLEd:  $(hlib)/HTKLib.a HLEd.o
	$(CC) HLEd.o $(hlib)/HTKLib.a -lm
	mv a.out $(HOME)/bin/HLEd
		
HLab2Net:  $(hlib)/HTKLib.a HLab2Net.o
	$(CC) HLab2Net.o $(hlib)/HTKLib.a -lm
	mv a.out $(HOME)/bin/HLab2Net

all:    HCode HList HInit HRest HERest HVite HMixUp HResults HLEd HLab2Net
