#include "common.h"

char    PROJECT[81];      /* ץ̾ */
char    SAVEDIR[81];      /* ¸եϥǥ쥯ȥ̾  */
char    TEMPDIR[81];      /* եϥǥ쥯ȥ̾  */

FILE   *argFP, *genFP, *zokFP, *expFP, *resFP, *strFP;

uchar  *BUFF;
uchar  *maxBUFF;     /* ݤƤ븶ʸΰνüɥ쥹 */
long    maxGOFS;     /* ºݤϤʸνü(offset)   */

int     outc=0;
int     tmpc=0;      /* եϲ               */
long    zokc=0;      /* ѤƤ°ΰΥȥ   */
int     dync=0;      /* ѤƤưŪʸΰθĿ     */

/*-----------------------------------------------------------------------------
  ѥ᡼ [xxx] γϥɥ쥹֤arg [ ؤƤ
-----------------------------------------------------------------------------*/
char  *fc_parameter (char *arg) {

  char  *p = strchr(arg+1, ']');

  *(p) = 0;
  return(arg+1);
}
/*---------------------------------------------------------------------------*/
char  *fc_savename (char *suffix) {

  static char savename[256];

  sprintf(savename, "%s/%s.%s", SAVEDIR, PROJECT, suffix);
  return(savename);
}
/*---------------------------------------------------------------------------*/
char  *fc_tempname (int number) {

  static char tempname[256];

  if (number < 0)
    sprintf(tempname, "%s/ngram.tmp", TEMPDIR);
  else
    sprintf(tempname, "%s/ngram.tmp.%d", TEMPDIR, number);

  return(tempname);
}
/*---------------------------------------------------------------------------*/
void fc_error () {

  fprintf(stderr,"  errno=%d ", errno);
  perror(NULL);
  fflush(stderr);
  exit(1);
}
/*---------------------------------------------------------------------------*/
FILE *fc_open (char *name, char *mode) {

  static FILE *fp;

  if ((fp = fopen(name, mode)) != NULL) return(fp);

  fprintf(stderr,"ERROR fopen name[%s] mode[%s]\n", name, mode);
  fc_error();
}
/*---------------------------------------------------------------------------*/
void fc_close (FILE *fp) {

  if (fclose(fp) == 0) return;
  fprintf(stderr,"ERROR fclose\n");
  fc_error();
}
/*---------------------------------------------------------------------------*/
void fc_seek (FILE *fp, int position, int mode) {

  if (fseek(fp, position, mode) == 0) return;

  fprintf(stderr,"ERROR fseek\n");
  fc_error();
}
/*---------------------------------------------------------------------------*/
void fc_read (void *buf, int size, FILE *fp) {

  if (fread((char *)buf, size, 1, fp) == 1) return;

  fprintf(stderr,"ERROR fread\n");
  fc_error();
}
/*---------------------------------------------------------------------------*/
int fx_read (void *buf, int size, FILE *fp) {

  if (fread((char *)buf, size, 1, fp) == 1) return(0);
  else                                      return(FINISH);
}
/*---------------------------------------------------------------------------*/
void fc_write (void *buf, int size, FILE *fp) {

  if (fwrite((char *)buf, size, 1, fp) == 1) return;

  fprintf(stderr,"ERROR fwrite\n");
  fc_error();
}
/*---------------------------------------------------------------------------*/
long fc_tell (FILE *fp) {

  return(ftell(fp));
}
/*---------------------------------------------------------------------------*/
uchar *fc_malloc (long size) {

  static uchar *p;

  if ((p = (uchar *)malloc(size)) != NULL) return(p);

  fprintf(stderr,"ERROR malloc size[%d]\n", size);
  fc_error();
}
/*---------------------------------------------------------------------------*/
uchar *fx_malloc (long size) {

  static uchar *p;

  p = (uchar *)malloc(size);
  return(p);
}
/*---------------------------------------------------------------------------*/
uchar *fc_realloc (void *p, long size) {

  return((uchar *)realloc(p, size));
}
/*---------------------------------------------------------------------------*/
void fc_free (void *p) {

  free(p);
}
/*---------------------------------------------------------------------------*/
int fc_type (uchar *arg) {

  if (*(arg) >= 0xA1) return(2);
  if (*(arg) ==    0) return(0);
  return(1);
}
/*-----------------------------------------------------------------------------
  pƬѤοʤ鿿֤
-----------------------------------------------------------------------------*/
int fc_isdigit (uchar *p) {

  return((memcmp(p, "", 2) >= 0) && (memcmp(p, "", 2) <= 0));
}
/*-----------------------------------------------------------------------------
  pƬѤαѻʤ鿿֤
-----------------------------------------------------------------------------*/
int fc_isalpha (uchar *p) {

  return(((memcmp(p, "", 2) >= 0) && (memcmp(p, "", 2) <= 0)) ||
	 ((memcmp(p, "", 2) >= 0) && (memcmp(p, "", 2) <= 0)));
}
/*-----------------------------------------------------------------------------
  pƬѤΥʤޤĹʤ鿿֤
-----------------------------------------------------------------------------*/
int fc_iskana (uchar *p) {

  return((memcmp(p, "", 2) == 0) ||
	 ((memcmp(p, "", 2) >= 0) && (memcmp(p, "", 2) <= 0)));
}
/*-----------------------------------------------------------------------------
  str1椫str2õƥɥ쥹֤
-----------------------------------------------------------------------------*/
uchar *fc_strstr (uchar *str1, uchar *str2) {

  uchar *hit, *k1, *k2;

  if ((hit = strstr(str1, str2)) == NULL) return(NULL);  /* ʤ */

  if (fc_type(hit) == 1) return(hit); /* str2ƬȾ(hit) */

  /* str2Ƭѡstr1򥷥եȤstrõ*/

  k1 = str1;
  k2 = str1 + strlen(str1) - strlen(str2);  /* õǽݥ */

  while (k1 <= k2) {
    if (strncmp(k1, str2, strlen(str2)) == 0) return(k1);
    k1 += fc_type(k1);
  }

  return(NULL);
}
/*---------------------------------------------------------------------------*/
char *fc_show (uchar *p) {

  int   i=0, j=0;
  static uchar tmp[GETSIZE];

  if (strlen(p) < 30) return((char *)p);

  while (j < 30) {
    if (fc_type(p+i) == 1) {
      tmp[j++] = *(p+i); i++;
    } else {
      tmp[j++] = *(p+i); i++;
      tmp[j++] = *(p+i); i++;
    }
  }

  tmp[j] = 0;
  return((char *)&tmp[0]);
}
/*---------------------------------------------------------------------------*/
char  *fc_show2 (zok_t *zok, uchar *buf) {

  static uchar tmp[GETSIZE];

  strcpy(tmp, buf);
  tmp[zok->gramb] = 0;
  return((char *)&tmp[0]);
}
/*---------------------------------------------------------------------------*/
