/* ----------------------------------------------------------- */
/*                   HTK  -  HMM Toolkit                       */
/* ----------------------------------------------------------- */
/*         Copyright: Steve Young      October 1989            */
/*         Cambridge University Engineering Department         */
/*         Trumpington Street, Cambridge, CB2 1PZ              */
/*                                                             */
/* Permission is hereby granted to copy, use and modify this   */
/* software provided that this banner notice is not removed    */
/*                                                             */
/* ----------------------------------------------------------- */
/*         File: HGraf.c:   Minimal Graphics Interface         */
/* ----------------------------------------------------------- */

#include <stdio.h>         /* Standard Libraries */
#include "/usr2/mcd/stdlib.h"
#include <string.h>

#include "HShell.h"
#include "HMath.h"
#include "HGraf.h"

/* ----------------------Dummy Version ------------ */



void TermGraf()
{
}

/* EXPORT-> InitHGraf: Create a window of given size and initialise */
void InitHGraf(int width, int height, char *name)
{
}

/* EXPORT-> HSetColour: Set current colour to c */
void HSetColour(Colour c)
{
}

/* EXPORT-> HSetGrey: Set current colour to the specified grey level*/
void HSetGrey(int level)
{
}

/* EXPORT-> HSetXMode: Set current transfer mode */
void HSetXMode(XferMode m)
{
}

/* EXPORT-> HDrawLine: Draw line from (x0,y0) to (x1,y1) */
void HDrawLine(int x0,int y0,int x1,int y1)
{
}

/* EXPORT-> HDrawRect: Draw rectangle */
void HDrawRect(int x0,int y0,int x1,int y1)
{
}

/* EXPORT-> HFillRect: Draw filled rectangle  */
void HFillRect(int x0,int y0,int x1,int y1)
{
}

/* EXPORT-> HDrawArc: Draw arc from stAngle thru arcAngle degrees */
void HDrawArc(int x0,int y0,int x1,int y1,int stAngle,int arcAngle)
{
}

/* EXPORT-> HFillArc: Draw filled arc from stAngle thru arcAngle degrees */
void HFillArc(int x0,int y0,int x1,int y1,int stAngle,int arcAngle)
{
}

/* EXPORT-> HSetTextSize: Set font size in points */
void HSetTextSize(int size)
{
}

/* EXPORT-> HDrawText: Draw the given text string */
void HDrawText(int x,int y, char *s)
{
}

/* EXPORT-> HTextWidth: Returns the width of the given string */
int HTextWidth(char *s)
{
}

/* EXPORT-> HPlotVector: plot vector v in given rectangle */
void HPlotVector(int x0,int y0,int x1,int y1, 
                 Vector v, int st, int en, float ymax, float ymin)
{
}

/* EXPORT-> HSpoolGraf: start saving an image of window in fname */
void HSpoolGraf(char *fname)
{
}


