hlib = ../HTKLib
CC = gcc 
CFLAGS = -I/usr/include -I$(hlib)  -g

HVPath:  $(hlib)/HTKLib.a HVPath.o
	$(CC) HVPath.o  $(hlib)/HTKLib.a  -lm
	mv a.out ../bin/HVPath

HCode:  $(hlib)/HTKLib.a HCode.o
	$(CC) HCode.o  $(hlib)/HTKLib.a  -lm
	mv a.out ../bin/HCode

HList:  $(hlib)/HTKLib.a HList.o
	$(CC) HList.o $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HList

HInit:  $(hlib)/HTKLib.a HInit.o HKMeans.o
	$(CC) HInit.o HKMeans.o $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HInit

HRest:  $(hlib)/HTKLib.a HRest.o
	$(CC) HRest.o  $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HRest

HERest:  $(hlib)/HTKLib.a HERest.o
	$(CC) HERest.o  $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HERest

HVite:  $(hlib)/HTKLib.a HVite.o
	$(CC) HVite.o  $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HVite

HMixUp:  $(hlib)/HTKLib.a HMixUp.o
	$(CC) HMixUp.o $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HMixUp
		
HResults:  $(hlib)/HTKLib.a HResults.o
	$(CC) HResults.o $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HResults
		
HLEd:  $(hlib)/HTKLib.a HLEd.o
	$(CC) HLEd.o $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HLEd
		
HLab2Net:  $(hlib)/HTKLib.a HLab2Net.o
	$(CC) HLab2Net.o $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HLab2Net

HGPD1:	$(hlib)/HTKLib.a HGPD1.o
	$(CC) HGPD1.o $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HGPD1

HGPD2:	$(hlib)/HTKLib.a HGPD2.o
	$(CC) HGPD2.o $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HGPD2

HGPD3:	$(hlib)/HTKLib.a HGPD3.o
	$(CC) HGPD3.o $(hlib)/HTKLib.a -lm
	mv a.out ../bin/HGPD3

all:    HCode HList HInit HRest HERest HVite HMixUp HResults HLEd HLab2Net \
	HGPD1 HGPD2 HGPD3 HVPath




