/*-----------------------------------------------------------------------------
  Ϣɽɽ

  1. ʸ°ɽγƥե򥪡ץ
  2. ʸեǽʸ¤˥
  3. ɽ˽и򽸷פϢɽɽ
-----------------------------------------------------------------------------*/
#include "common.h"

#define DEBUGP3 0

char RENSA_FREQ;       /* ɽϢɽٿ  β */
char RENSA_GRAM;       /* ɽϢɽʸβ */
char RENSA_JDOSU;      /* ٿ                         */
char RENSA_JRITU;      /* Ψ                         */

FILE *p3aFP;        /* ٽ̥ޥ꡼ե   */
FILE *p3bFP;        /* ٽ̥ե           */
FILE *renFP;        /* Хǡΰϥե */

typedef struct {    /* Хǡ              */
  int   freq;       /*                     */
  int   strno;      /*   ʸֹ            */
  long  gexp;       /*   ɽgenFPoffset */
  char  gramb;      /*   ХХȿ          */
  char  type;       /*   Х            */
} ren_t;

int  typeA=0, typeB=0, typeC=0, maxStrno=0;

void   f3_start     (char  *);
void   f3_parameter (char  *);
void   f3_exec      ();
int    f3_input     (zok_t *);
void   f3_output    (zok_t *, int, int);
void   f3_result    ();
/*---------------------------------------------------------------------------*/
void main (int argc, char **argv) {

  if (argc != 2)
    fprintf(stderr,"usage: %s parameter-filename\n", argv[0]);
  else
    f3_start(argv[1]);

  exit(0);
}
/*---------------------------------------------------------------------------*/
void f3_start (char *param) {

  f3_parameter(param);

  genFP = fc_open(fc_savename("gen"), "r");   /* ʸե */
  zokFP = fc_open(fc_savename("zok"), "r");   /* °ե */
  expFP = fc_open(fc_savename("exp"), "r");   /* ɽե */
  p3aFP = fc_open(fc_savename("p3a"), "w");   /* ̥ե */
  strFP = fc_open(fc_savename("str"), "w+");  /* ѥե */
  p3bFP = fc_open(fc_savename("p3b"), "w+");
  renFP = fc_open(fc_savename("que"), "w+");

  fprintf(p3aFP, "ٿ   %d\n",     RENSA_FREQ);
  fprintf(p3aFP, "ʸ %d\n",     RENSA_GRAM);
  fprintf(p3aFP, "ٿ %d\n",     RENSA_JDOSU);
  fprintf(p3aFP, "Ψ %d%s\n\n", RENSA_JRITU, " %");

  f3_exec();

  fprintf(p3aFP, "\n");
  fprintf(p3aFP, "(A) иˤ %6d\n", typeA);
  fprintf(p3aFP, "(B) ٿˤ %6d\n", typeB);
  fprintf(p3aFP, "(C) Ψˤ %6d\n", typeC);

  f3_result();

  fc_close(genFP);
  fc_close(zokFP);
  fc_close(expFP);
  fc_close(p3aFP);
  fc_close(strFP);
  fc_close(p3bFP);
  fc_close(renFP);
}
/*---------------------------------------------------------------------------*/
void f3_parameter (char *param) {

  char  buf[256];

  argFP = fc_open(param, "r");

  while (fgets(buf, 255, argFP) != NULL) {

    if (memcmp(buf, "PROJECT", 7) == 0)
      strcpy(PROJECT, fc_parameter(&buf[8]));

    else if (memcmp(buf, "SAVE", 4) == 0)
      strcpy(SAVEDIR, fc_parameter(&buf[5]));

    else if (memcmp(buf, "TEMP", 4) == 0)
      strcpy(TEMPDIR, fc_parameter(&buf[5]));

    else if (memcmp(buf, "FREQ", 4) == 0)
      RENSA_FREQ = atoi(fc_parameter(&buf[5]));

    else if (memcmp(buf, "GRAM", 4) == 0)
      RENSA_GRAM = atoi(fc_parameter(&buf[5]));

    else if (memcmp(buf, "JDOSU", 5) == 0)
      RENSA_JDOSU = atoi(fc_parameter(&buf[6]));

    else if (memcmp(buf, "JRITU", 5) == 0)
      RENSA_JRITU = atoi(fc_parameter(&buf[6]));
  }

  fclose(argFP);
}
/*-----------------------------------------------------------------------------
  и򽸷פɽ˽                           

     о:  & ʸRENSA_GRAM & иRENSA_FREQ 
-----------------------------------------------------------------------------*/
void f3_exec () {

  int     in, out, eof=0;
  zok_t   zok1, zok2;

  /* ѥե˥ߡХȤ */
  fc_write(&eof, sizeof(int), strFP);

  /* Ƭξ */
  if (f3_input(&zok1) == FINISH) return;

  while (1) {
    in = out = 0;
    if (zok1.saihi == 0) in  = 1;
    else                 out = 1;

    /* ³ɽϤƱɽνи򥫥Ȥ */
    while (1) {
      /* ξ */
      if (f3_input(&zok2) == FINISH) { eof=1; break; }
      if (zok1.gramc != zok2.gramc) break;            /* ʸ㤦   */
      if (zok1.gramb != zok2.gramb) break;            /* Хȿ㤦 */
      if (zok1.strno != zok2.strno) break;            /* ʸ󤬰㤦   */

      if (zok2.saihi == 0) in++;
      else                 out++;
    }

    f3_output(&zok1, in, out);
    if (eof) break;

    /* ؤ */
    memcpy((char *)&zok1, (char *)&zok2, sizeof(zok_t));
  }

  /* ѥեƬ˺strno */
  fc_seek(strFP, 0, 0);
  fc_write(&maxStrno, sizeof(int), strFP);
}
/*-----------------------------------------------------------------------------
  ֤expFPɽϤzokFP鳺°Ϥ

   1. expFPEOFʤFINISH֤
   2. gramc>=RENSA_GRAM ɽ֤
-----------------------------------------------------------------------------*/
int f3_input (zok_t *zok) {

  long  zofs;

  while (fx_read(&zofs, sizeof(long), expFP) != FINISH) {
    /* ° */
    fc_seek(zokFP, zofs, 0);
    fc_read(zok, sizeof(zok_t), zokFP);
    if (zok->gramc >= RENSA_GRAM) return(0);
  }

  return(FINISH);
}
/*-----------------------------------------------------------------------------
  Τ줫ξ˽Ϥ

  и  RENSA_FREQ

     RENSA_JDOSU  0
      && и 0
      && ии  RENSA_JDOSU

   RENSA_JRITU  0
      && и  (ии)  RENSA_RITU
      && ии  RENSA_FREQ
-----------------------------------------------------------------------------*/
void f3_output (zok_t *zok, int in, int out) {

  int   freq;
  char  type=' ';
  ren_t ren;

  if (   (RENSA_JRITU > 0)
      && ((out * 100 / (out + in)) >= RENSA_JRITU)
      && ((out + in) >= RENSA_FREQ)) {
    type = 'C';
    freq = out + in;
    typeC++;

  } else if (   (RENSA_JDOSU > 0)
	     && (out        >  0)
	     && ((out + in) >= RENSA_JDOSU)) {
    type = 'B';
    freq = out + in;
    typeB++;

  } else if (out >= RENSA_FREQ) {
    type = 'A';
    freq = out;
    typeA++;

  } else return;

  ren.freq = freq;
  ren.strno = zok->strno;
  ren.gexp  = zok->gexp;
  ren.gramb = zok->gramb;
  ren.type  = type;
  fc_write(&ren, sizeof(ren_t), renFP);

  fc_write(&zok->strno, sizeof(long), strFP);

  if (zok->strno > maxStrno) maxStrno = zok->strno;
}
/*---------------------------------------------------------------------------*/
static int f3_compare (ren_t *ren1, ren_t *ren2) {

  if (ren1->freq > ren2->freq) return(-1);
  if (ren1->freq < ren2->freq) return( 1);

  if (ren1->strno < ren2->strno) return(-1);
  if (ren1->strno > ren2->strno) return( 1);

  return(0);
}
/*---------------------------------------------------------------------------*/
void f3_report (ren_t *ren) {

  static int  prev=0, sumA=0, sumB=0, sumC=0, typeA, typeB, typeC;
  char   buf[GETSIZE];

  if (ren == NULL) {  /* EOF */
    if (prev > 0)
      fprintf(p3aFP, "%8d : %8d  %8d  %8d  %8d\n",
	      prev, typeA, typeB, typeC, typeA + typeB + typeC);
    fprintf(p3aFP, " -------------------------------------------------\n");
    fprintf(p3aFP, "%8s : %8d  %8d  %8d  %8d\n\n",
	    "   total", sumA, sumB, sumC, sumA + sumB + sumC);
    return;
  }

  if (ren->freq != prev) { /* ľ٤Ȱ㤦 */
    if (prev > 0)
      fprintf(p3aFP, "%8d : %8d  %8d  %8d  %8d\n",
	      prev, typeA, typeB, typeC, typeA + typeB + typeC);
    prev = ren->freq;
    typeA = 0;
    typeB = 0;
    typeC = 0;
  }	

  fc_seek(genFP, ren->gexp, 0);
  fgets(buf, RECSIZE, genFP);
  buf[ren->gramb] = 0;
  fprintf(p3bFP, "%8d  %c  %s\n", ren->freq, ren->type, buf);
  switch (ren->type) {
  case 'A': typeA++; sumA++; break;
  case 'B': typeB++; sumB++; break;
  case 'C': typeC++; sumC++; break;
  }
}
/*---------------------------------------------------------------------------*/
void f3_temporary_output (ren_t *top, ren_t *end) {

  FILE *fp = fc_open(fc_tempname(tmpc++), "w");
  int   n  = ((char *)end - (char *)top) / sizeof(ren_t);

  qsort(top, n, sizeof(ren_t), f3_compare);

  while (top < end) {
    fc_write(top, sizeof(ren_t), fp);
    top++;
  }
  fc_close(fp);
}
/*-----------------------------------------------------------------------------
  ٽ˥ȤƤեޡp3bFPԽϤ
-----------------------------------------------------------------------------*/
void  f3_temporary_merge () {

  int     i, m, eofc=0, eof[MAXTMPC];
  FILE   *inpf[MAXTMPC];
  ren_t   ren [MAXTMPC];

#if DEBUGP3
  printf("temporary_merge tmpc=%d\n", tmpc); fflush(stdout);
#endif

  /*---------------------------------------------------------+
   | ե򥪡ץ󤷤ren[]˰°Ϥ |
   +---------------------------------------------------------*/
  for (i=0; i<tmpc; i++) {
    inpf[i] = fc_open(fc_tempname(i), "r");
    eof [i] = 0;
    fc_read(&ren[i], sizeof(ren_t), inpf[i]);
  }

  /*------------+
   | ޡ |
   +------------*/

  while (1) {

    m  = -1;

    /* Ǿɽõ */

    for (i=0; i<tmpc; i++) {
      if (eof[i] == 0) {
	if (m < 0)
	  m = i;
	else if (f3_compare(&ren[i], &ren[m]) < 0) m = i;
      }
    }

    /*--------------------+
     | ren[m]Ǿä |
     +--------------------*/

    f3_report(&ren[m]);

    /* ξ */
    if (fx_read(&ren[m], sizeof(ren_t), inpf[m]) == FINISH) {
      fc_close(inpf[m]);
      unlink(fc_tempname(m));
      if (++eofc == tmpc) break;    /* ե뽪λ */
      eof[m] = 1;
    }
  }

  f3_report(NULL);
}
/*---------------------------------------------------------------------------*/

void f3_result () {

  int    i, filesize = ftell(renFP), renc=filesize/sizeof(ren_t);
  ren_t *RENS, *ren;

  fprintf(p3aFP,"\n\n    ٿ        (A)       (B)       (C)     total\n");
  fprintf(p3aFP,    " -------------------------------------------------\n");

  fc_seek(renFP, 0, 0);

  if ((ren = RENS = (ren_t *)fc_malloc(filesize)) != NULL) {

    for (i=0; i<renc; i++) fx_read(ren++, sizeof(ren_t), renFP);
    qsort(RENS, renc, sizeof(ren_t), f3_compare);
    ren = RENS;

    for (i=0; i<renc; i++) {
      f3_report(ren);
      ren++;
    }

    f3_report(NULL);
    fc_free(RENS);

  } else {   /* renFPΥΰݼ */

    char *renMAX;

    ren = RENS = (ren_t *)fc_malloc(INITBUFF);
    renMAX = (char *)ren + INITBUFF;

    for (i=0; i<renc; i++) {
      if ((char *)ren+sizeof(ren_t) > renMAX) {
	f3_temporary_output(RENS, ren);
	ren = RENS;
      }
      fc_read(ren, sizeof(ren_t), renFP);
      ren++;
    }

    f3_temporary_output(RENS, ren);
    fc_free(RENS);
    f3_temporary_merge();
  }
}
/*---------------------------------------------------------------------------*/
